package com.steerinfo.dil.feign;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @author hujianguo
 * @create 2021-10-29 11:23
 */
@FeignClient(value = "dil-join-api-dev", url = "${openfeign.JoinFeign.url}")
public interface JoinFeign {
    // 得到销售订单信息
    @PostMapping("/api/v1/join/amssaleorder/getSaleOrder")
    Map<String,Object> getSaleOrder(@RequestParam BigDecimal saleOrderId);

    // 推送销售订单到金蝶
    @PostMapping("/api/v1/join/wsface/pushSaleOrderToEas")
    Map<String,Object> pushSaleOrderToEas(@RequestBody Map<String,Object> map);

    // 同步关闭金蝶销售订单
    @PostMapping("/api/v1/join/wsface/deleteSaleOrderToEas")
    Map<String,Object> deleteSaleOrderToEas(@RequestBody Map<String,Object> map);

    // 推送车牌号到金蝶
    @PostMapping("/api/v1/join/wsface/pushCarNumberToEas")
    Map<String,Object> pushCarNumberToEas(@RequestBody Map<String,Object> map);

    // 查询车牌号和金蝶分录
    @PostMapping("/api/v1/join/amssaleorder/findCarNumberByOrderId")
    Map<String,Object> findCarNumberByOrderId(@RequestParam BigDecimal saleOrderMaterialId);

    //根据数组查询车牌号、承运商和金蝶分录
    @PostMapping("/api/v1/join/amssaleorder/findCarNumberByOrderList")
    Map<String, Object> findCarNumberByOrderList(@RequestBody List<Map<String, Object>> mapList);

    //注册收货客户
    @PostMapping("/api/v1/join/rmsconsignee/registerConsignee")
    Map<String, Object> registerConsignee(@RequestBody Map<String, Object> map);
}
