package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsContractTransportPrice;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface AmsContractTruckPriceMapper extends IBaseMapper<AmsContractTransportPrice, BigDecimal> {
    //查询主键最大值
    @Select("select seq_truck_price.nextval from dual")
    BigDecimal selectMaxId();

    //查询物资价格中间表主键最大值
    @Select("select seq__ams_price_material.nextval from dual")
    BigDecimal selectPriceMaterialMaxId();
    //获取汽运单价信息
    List<Map<String, Object>> getAmsContractTransportPrice(Map<String,Object> map);
    //获取运价信息
    Map<String,Object> getAmsContractTransportPriceForImport(String address);
    //根据省市县查询出addressId
    BigDecimal getAddressIdForImport(String address);
    //新增地址
    int insertIntoRRAForImport(String addressProvince,String addressDistrict,String addressTown);
    //获取承运商
    BigDecimal getCarrierIdForCarrierName(String carrierName);
    //根据单价去查询数据
    List<BigDecimal> getCarrierIdForImport(String address);
    //更新旧单价为1
    int updateForImport(BigDecimal priceId, String date);
    //删除单价
    int deleteSalePrice(Map<String,Object> map);
    //获取全部承运商信息
    List<Map<String,Object>> getCarrierListByPrice(Map<String,Object> map);
    //获取全部承运商信息(根据单价地址获得的具体的承运商)
    List<Map<String,Object>> getCarrierListByAddress(Map<String,Object> map);
    //获取全部承运商信息(根据单价地址获得的具体的承运商)
    List<Map<String,Object>> getCarrierListByAddressNew(Integer addressId,String addressDeliveryAddress);
    //新增是刷新旧数据
    int updateOldDate(Map<String,Object> map);
    //删除单价信息
    int deleteSomeOneSalePrice(Map<String,Object> map);
    //修改单价信息
    int updateSomeOneSalePrice(Map<String,Object> map);
    //更新卸货地址
    int updateaddressDeliveryAddress(Map<String,Object> map);
    //更新单价
    int updatePriceValue(Map<String,Object> map);
    //更新单价(无运输距离)
    int updatePriceValueNew(Map<String,Object> map);
    //更新单价
    int updateHaulDistance(Map<String,Object> map);
    //获取承运商信息
    String getCarrierNameForDetail(String userId);
    //获取收货地址的信息
    List<Map<String,Object>> getReceiveAddressId(Map<String,Object> map);
    //改deleted为1
    int updateDeletedTemplate(BigDecimal priceId);
    //获取已经计算出的单价值
    AmsContractTransportPrice getOnePriceMap(Map<String,Object> map);
    //获取汽运单价信息
    List<Map<String, Object>> getAmsContractTransportPriceForDetail(Map<String,Object> map);
    //获取承运商名称
    List<Map<String, Object>> getCarrierName();
    //获取线路编号
    List<Map<String, Object>> getLineNo();
    //获取运力编号
    List<Map<String, Object>> getCapacityNumber();
    //获取收货地址
    List<Map<String, Object>> getAddressDeliveryAddress(Map<String,Object> map);
    //获取收货地址(专门给计费详单使用)
    List<Map<String, Object>> getAddressDeliveryAddressForDetails(Map<String,Object> map);
    //获取要渲染的信息
    List<Map<String, Object>> selectByPriceId(BigDecimal priceId);
    //获取所有的油价
    List<Map<String, Object>> getOriginAndNowOilPrice();
    //通过油价变动率批量修改油价
    int batchUpdateTransportPriceByOilPrice(Double updateOilPrice);
    //通过主键查询参考运距
    BigDecimal getLinePathLength(BigDecimal lineId);
    //获取符合条件运价数值列表
    List<Map<String, Object>> getPriceValueList(BigDecimal oilTypeId);
    //获取运价和吨公里数值列表
    List<Map<String, Object>> getPriceValueAndPriceTonKilometer();
    //通过主键修改吨公里数
    int updatePriceTonKilometer(BigDecimal priceId,BigDecimal priceTonKilometer);
    //获取焦炭运价计算公式
    String getTruckFormula(BigDecimal formulaId);
    //查询货物名称
    String getCargonameValue(BigDecimal cargonameId);
    //获取货物类型
    List<Map<String, Object>> getCargoName();
    //获取油品名称
    List<Map<String, Object>> getOilTypeName();
    // 边输边查具体地址
    List<Map<String, Object>> getRealAddressByLike(Map<String, Object> map);

    BigDecimal selectFormulaId(BigDecimal priceId);

    List<Map<String, Object>> getInwardContractPrice(Map<String, Object> mapValue);

    List<Map<String, Object>> selectInwardPrice(Map<String, Object> mapvalue);

    List<Map<String, Object>> getRangePoint(Map<String, Object> mapValue);

    List<Map<String, Object>> selectwz(Map<String, Object> map);

    Map<String, Object> getcargonameId(Map<String, Object> map);

    int updateDCodd();

    int updateDCnew();

    Map<String, Object> selectByPlaceId(BigDecimal priceId);

    int updateByPriceId(Map<String, Object> updatePrice);

    int updateDelectByPlaceId(Map<String, Object> map);

    List<String> selectshdz(Map<String, Object> map);

    Map<String, Object> selectxxdz(Map<String, Object> map);

    void insertxxdz(Map<String, Object> map);

    Map<String, Object> selectcys(String cys);

    int selectMaxIdrrp();

    int selectMaxIdrra();

    void insertshdz(Map<String, Object> map);

    List<Map<String, Object>> getPriceValueListInward(BigDecimal oilTypeId);

    //子表信息复制新增、
    int insertIntoAmsContractForMaterial(Map<String,Object> map);

    //getAmsContractMaterialData
    List<Map<String, Object>> getAmsContractMaterialData(BigDecimal priceId);

    int updatePriceToDelete();

}