package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsSaleMaterial;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface AmsSaleMaterialMapper extends IBaseMapper<AmsSaleMaterial, BigDecimal> {
    @Select("select seq_AMS_SALE_MATERIAL.nextval from dual")
    BigDecimal selectMaxId();
    // 得到物资出现次数
    Integer getMaterialCount(BigDecimal materialId);
    // 根据路段顺序号逆序找到装货实际
    List<Map<String, Object>> findLoadIdList(BigDecimal saleOrderMaterialId);
    // 根据路段顺序号逆序找到计量实际
    List<Map<String, Object>> findWeightIdList(BigDecimal saleOrderMaterialId);
    //
    int deleteLoadResult(BigDecimal loadId);
    //
    int deleteWeightResult(BigDecimal weightId);

    int updateOrderMaterialToClose(Map<String, Object> mapValue);

    int deleteWmspOutResult(Map<String, Object> mapValue);
    // 开启所有的分录
    int openAllSaleMaterial(BigDecimal saleOrderId);
    // 反关闭分录
    int adverseCloseSaleMaterial(BigDecimal saleMaterialId);

    int getOrderResults(BigDecimal orderId);

    int updateSaleMaterial(BigDecimal saleOrderMaterialId);

    int getSaleMaterialDelete(BigDecimal saleOrderMaterialId);

    int updateSaleMaterialMakeDate(Map<String, Object> rowSet);

    BigDecimal selectTransPortOrderId(BigDecimal closeWlEntryId);

    List<BigDecimal> getSaleMaterialIds(BigDecimal saleOrderMaterialId);

    int getSaleMaterialWeight(Map<String, Object> mapValue);

    Integer getAbleFlcount(BigDecimal saleOrderMaterialId);

    BigDecimal getToOrderId(BigDecimal saleMaterialId);

    int getSaleMaterialDeleteBySaleMaterialId(BigDecimal saleMaterialId);

}