package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsSaleOrderMaterial;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Mapper
public interface AmsSaleOrderMaterialMapper extends IBaseMapper<AmsSaleOrderMaterial, BigDecimal> {
    //查询主键最大值
    @Select("select seq_AMS_SALE_ORDER_MATERIAL.nextval from dual")
    BigDecimal selectMaxId();
    //查询收货地址主键最大值
    BigDecimal selectMaxIdReceive();
    //新增收货地址
    int insertReceiveAddress(Map<String, Object> map);
    //获取要渲染的值
    List<Map<String, Object>> selectBySaleOrderMaterialId(BigDecimal saleOrderMaterialId);
    //通过主键获得收货地址
    String getAddress(BigDecimal saleOrderMaterialId);
    //获取收货地址id
    BigDecimal getReceiveAddressId(String saleShippingAddress);
    //获取收货地址
    List<Map<String, Object>> getAddressDeliveryAddress();
    List<Map<String, Object>> getSaleMaterial(Map<String, Object> mapValue);

    Integer selectById(BigDecimal saleOrderMaterialId);

    Integer selectByCxh(Map<String, Object> m);

    // 车序号信息
    List<Map<String, Object>> getTruckNoList(Map<String, Object> mapValue);

    // 物资详情
    List<Map<String, Object>> getTruckNoMaterialList(BigDecimal saleOrderMaterialId);

    // 销售订单下的
    List<Map<String, Object>> getSaleMaterialList(BigDecimal saleOrderId);

    // 通过车牌号查询运力id
    BigDecimal getCapacityId(String capacityNumber);

    //计算同一销售订单的物资重量
    BigDecimal getMaterialWeightByOrderId(BigDecimal saleOrderId);
    //计算同一销售下的物资总净量
    BigDecimal getMaterialNetWeightBySaleId(BigDecimal saleOrderId);
    // 得到是否是钢材
    BigDecimal getIsSteel(BigDecimal lineId);

    List<Map<String, Object>> getPlaceId(String place,BigDecimal shippingAddressId);
    //通过收货地址ID去查询单价信息
    BigDecimal getPriceIdForUpdate(BigDecimal placeId);
    //更新单价Id
    int updateOmstruckOrder(BigDecimal priceId,BigDecimal orderId);
    // 通过销售订单id查询出销售订单信息
    Map<String, Object> getSaleMessage(BigDecimal saleOrderId);
    // 通过承运商id查询单价
    List<Map<String, Object>> getPriceList(BigDecimal carrierId);
    //通过地址ID查询单价
    BigDecimal getPriceByPlace(BigDecimal placeId);
    // 查询车序号中的物资
    List<Map<String, Object>> getMaterial(BigDecimal saleOrderMaterialId);
    //更新发站
    int updateSendStation(Map<String, Object> mapValue);

    //更新收货客户
    int updateInwardConsignee(Map<String, Object> mapValue);

    int selectSaleOrderIdIsUpload(BigDecimal saleOrderId);

    String getAddressRemark(BigDecimal saleShippingAddressId);

    int updateTransportOrderStatus(@Param("orderId") BigDecimal orderId, @Param("orderStatus") Integer orderStatus);

    int deleteToMergeOrder(BigDecimal orderId);

    BigDecimal selectEnFactory(BigDecimal orderId);

    //把现地址赋值给旧地址字段
    int setHistoryAddressId(Map<String, Object> mapValue);

    BigDecimal getDeatailsOrder(BigDecimal closeWlEntryId);

    int getNetWeightCount(BigDecimal orderId);

    int deleteToMergeOrderMaterial(BigDecimal orderId);

    BigDecimal getResultTotalId(BigDecimal previousOrderId);

    BigDecimal getDispatchedOrderWeight(BigDecimal saleOrderId);

    int selectSaleOrdeNoIsUpload(String saleOrderNo);

    void updateSaleOrderReceipt(BigDecimal saleOrderId, Date receiptDateByDate);

    Date getOldDateOfReceipt(BigDecimal saleOrderId);

    int getOrderCount(BigDecimal saleOrderMaterialId);

    int updateOrderCarrier(@Param("saleOrderMaterialId") BigDecimal saleOrderMaterialId, @Param("carrierId") BigDecimal carrierId);

    BigDecimal getMaxCxh(BigDecimal saleOrderId);

}