package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;

@ApiModel(value="单价与物资中间表")
public class AmsContaactPriceMaterial implements IBasePO<BigDecimal> {
    /**
     * 主键ID(PRICE_MATERIAL_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal priceMaterialId;

    /**
     * 单价ID(PRICE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="单价ID",required=false)
    private BigDecimal priceId;

    /**
     * 物资ID(MATERIAL_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="物资ID",required=false)
    private BigDecimal materialId;

    /**
     * 逻辑删除,0,未删除，1删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除,0,未删除，1删除",required=false)
    private BigDecimal deleted;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.priceMaterialId;
    }

    @Override
    public void setId(BigDecimal priceMaterialId) {
        this.priceMaterialId = priceMaterialId;
    }

    public BigDecimal getPriceMaterialId() {
        return priceMaterialId;
    }

    public void setPriceMaterialId(BigDecimal priceMaterialId) {
        this.priceMaterialId = priceMaterialId;
    }

    public BigDecimal getPriceId() {
        return priceId;
    }

    public void setPriceId(BigDecimal priceId) {
        this.priceId = priceId;
    }

    public BigDecimal getMaterialId() {
        return materialId;
    }

    public void setMaterialId(BigDecimal materialId) {
        this.materialId = materialId;
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", priceMaterialId=").append(priceMaterialId);
        sb.append(", priceId=").append(priceId);
        sb.append(", materialId=").append(materialId);
        sb.append(", deleted=").append(deleted);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}