package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="销售订单分录物资中间表")
public class AmsSaleMaterial implements IBasePO<BigDecimal> {
    /**
     * 主键ID(SALE_MATERIAL_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal saleMaterialId;

    /**
     * 销售订单主表主键ID(SALE_ORDER_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="销售订单主表主键ID",required=false)
    private BigDecimal saleOrderId;

    /**
     * 物资ID(MATERIAL_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="物资ID",required=false)
    private BigDecimal materialId;

    /**
     * 物资重量(MATERIAL_WEIGHT,DECIMAL,0)
     */
    @ApiModelProperty(value="物资重量",required=false)
    private BigDecimal materialWeight;

    /**
     * 物资件数(MATERIAL_NUMBER,DECIMAL,38)
     */
    @ApiModelProperty(value="物资件数",required=false)
    private BigDecimal materialNumber;

    /**
     * 金蝶分路主键ID(EAS_PRIMARY_ID,VARCHAR,30)
     */
    @ApiModelProperty(value="金蝶分路主键ID",required=false)
    private String easPrimaryId;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除 0:未删除 ；1：已删除(DELETED,DECIMAL,38)
     */
    @ApiModelProperty(value="逻辑删除 0:未删除 ；1：已删除",required=false)
    private BigDecimal deleted;

    /**
     * 仓库所在厂区(SALE_WAREHOUSE,VARCHAR,50)
     */
    @ApiModelProperty(value="仓库所在厂区",required=false)
    private String saleWarehouse;

    /**
     * 米数(STEEL_METER,DECIMAL,0)
     */
    @ApiModelProperty(value="米数",required=false)
    private BigDecimal steelMeter;

    /**
     * 是否磅重销售 0：磅重 1：理重(IS_POUND_SALE,DECIMAL,0)
     */
    @ApiModelProperty(value="是否磅重销售 0：磅重 1：理重",required=false)
    private BigDecimal isPoundSale;

    /**
     * 物资理重(METER_WEIGHT,DECIMAL,0)
     */
    @ApiModelProperty(value="物资理重",required=false)
    private BigDecimal meterWeight;

    /**
     * 调出仓库(TRANSFER_OUT_OF_WAREHOUSE,VARCHAR,50)
     */
    @ApiModelProperty(value="调出仓库",required=false)
    private String transferOutOfWarehouse;

    /**
     * 调入仓库(TRANSFER_IN_OF_WAREHOUSE,VARCHAR,50)
     */
    @ApiModelProperty(value="调入仓库",required=false)
    private String transferInOfWarehouse;

    /**
     * 库存类型(INVENTORY_TYPE,VARCHAR,50)
     */
    @ApiModelProperty(value="库存类型",required=false)
    private String inventoryType;

    /**
     * 库存状态(INVENTORY_STATUS,VARCHAR,50)
     */
    @ApiModelProperty(value="库存状态",required=false)
    private String inventoryStatus;

    /**
     * 调入计划日期(TRANSFER_IN_PLAN_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="调入计划日期",required=false)
    private Date transferInPlanDate;

    /**
     * 调出计划日期(TRANSFER_OUT_PLAN_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="调出计划日期",required=false)
    private Date transferOutPlanDate;

    /**
     * 是否控制数量(CONTROL_QUANTITY,VARCHAR,20)
     */
    @ApiModelProperty(value="是否控制数量",required=false)
    private String controlQuantity;

    /**
     * 制单日期(SALE_MAKE_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="制单日期",required=false)
    private Date saleMakeDate;

    /**
     * 计划件数(MATERIAL_PLAN_NUMBER,DECIMAL,0)
     */
    @ApiModelProperty(value="计划件数",required=false)
    private BigDecimal materialPlanNumber;

    /**
     * 销售订单号(SALE_NO,VARCHAR,255)
     */
    @ApiModelProperty(value="销售订单号",required=false)
    private String saleNo;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.saleMaterialId;
    }

    @Override
    public void setId(BigDecimal saleMaterialId) {
        this.saleMaterialId = saleMaterialId;
    }

    public BigDecimal getSaleMaterialId() {
        return saleMaterialId;
    }

    public void setSaleMaterialId(BigDecimal saleMaterialId) {
        this.saleMaterialId = saleMaterialId;
    }

    public BigDecimal getSaleOrderId() {
        return saleOrderId;
    }

    public void setSaleOrderId(BigDecimal saleOrderId) {
        this.saleOrderId = saleOrderId;
    }

    public BigDecimal getMaterialId() {
        return materialId;
    }

    public void setMaterialId(BigDecimal materialId) {
        this.materialId = materialId;
    }

    public BigDecimal getMaterialWeight() {
        return materialWeight;
    }

    public void setMaterialWeight(BigDecimal materialWeight) {
        this.materialWeight = materialWeight;
    }

    public BigDecimal getMaterialNumber() {
        return materialNumber;
    }

    public void setMaterialNumber(BigDecimal materialNumber) {
        this.materialNumber = materialNumber;
    }

    public String getEasPrimaryId() {
        return easPrimaryId;
    }

    public void setEasPrimaryId(String easPrimaryId) {
        this.easPrimaryId = easPrimaryId == null ? null : easPrimaryId.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public String getSaleWarehouse() {
        return saleWarehouse;
    }

    public void setSaleWarehouse(String saleWarehouse) {
        this.saleWarehouse = saleWarehouse == null ? null : saleWarehouse.trim();
    }

    public BigDecimal getSteelMeter() {
        return steelMeter;
    }

    public void setSteelMeter(BigDecimal steelMeter) {
        this.steelMeter = steelMeter;
    }

    public BigDecimal getIsPoundSale() {
        return isPoundSale;
    }

    public void setIsPoundSale(BigDecimal isPoundSale) {
        this.isPoundSale = isPoundSale;
    }

    public BigDecimal getMeterWeight() {
        return meterWeight;
    }

    public void setMeterWeight(BigDecimal meterWeight) {
        this.meterWeight = meterWeight;
    }

    public String getTransferOutOfWarehouse() {
        return transferOutOfWarehouse;
    }

    public void setTransferOutOfWarehouse(String transferOutOfWarehouse) {
        this.transferOutOfWarehouse = transferOutOfWarehouse == null ? null : transferOutOfWarehouse.trim();
    }

    public String getTransferInOfWarehouse() {
        return transferInOfWarehouse;
    }

    public void setTransferInOfWarehouse(String transferInOfWarehouse) {
        this.transferInOfWarehouse = transferInOfWarehouse == null ? null : transferInOfWarehouse.trim();
    }

    public String getInventoryType() {
        return inventoryType;
    }

    public void setInventoryType(String inventoryType) {
        this.inventoryType = inventoryType == null ? null : inventoryType.trim();
    }

    public String getInventoryStatus() {
        return inventoryStatus;
    }

    public void setInventoryStatus(String inventoryStatus) {
        this.inventoryStatus = inventoryStatus == null ? null : inventoryStatus.trim();
    }

    public Date getTransferInPlanDate() {
        return transferInPlanDate;
    }

    public void setTransferInPlanDate(Date transferInPlanDate) {
        this.transferInPlanDate = transferInPlanDate;
    }

    public Date getTransferOutPlanDate() {
        return transferOutPlanDate;
    }

    public void setTransferOutPlanDate(Date transferOutPlanDate) {
        this.transferOutPlanDate = transferOutPlanDate;
    }

    public String getControlQuantity() {
        return controlQuantity;
    }

    public void setControlQuantity(String controlQuantity) {
        this.controlQuantity = controlQuantity == null ? null : controlQuantity.trim();
    }

    public Date getSaleMakeDate() {
        return saleMakeDate;
    }

    public void setSaleMakeDate(Date saleMakeDate) {
        this.saleMakeDate = saleMakeDate;
    }

    public BigDecimal getMaterialPlanNumber() {
        return materialPlanNumber;
    }

    public void setMaterialPlanNumber(BigDecimal materialPlanNumber) {
        this.materialPlanNumber = materialPlanNumber;
    }

    public String getSaleNo() {
        return saleNo;
    }

    public void setSaleNo(String saleNo) {
        this.saleNo = saleNo == null ? null : saleNo.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", saleMaterialId=").append(saleMaterialId);
        sb.append(", saleOrderId=").append(saleOrderId);
        sb.append(", materialId=").append(materialId);
        sb.append(", materialWeight=").append(materialWeight);
        sb.append(", materialNumber=").append(materialNumber);
        sb.append(", easPrimaryId=").append(easPrimaryId);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", saleWarehouse=").append(saleWarehouse);
        sb.append(", steelMeter=").append(steelMeter);
        sb.append(", isPoundSale=").append(isPoundSale);
        sb.append(", meterWeight=").append(meterWeight);
        sb.append(", transferOutOfWarehouse=").append(transferOutOfWarehouse);
        sb.append(", transferInOfWarehouse=").append(transferInOfWarehouse);
        sb.append(", inventoryType=").append(inventoryType);
        sb.append(", inventoryStatus=").append(inventoryStatus);
        sb.append(", transferInPlanDate=").append(transferInPlanDate);
        sb.append(", transferOutPlanDate=").append(transferOutPlanDate);
        sb.append(", controlQuantity=").append(controlQuantity);
        sb.append(", saleMakeDate=").append(saleMakeDate);
        sb.append(", materialPlanNumber=").append(materialPlanNumber);
        sb.append(", saleNo=").append(saleNo);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}