package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="销售订单")
public class AmsSaleOrder implements IBasePO<BigDecimal> {
    /**
     * 主键ID(SALE_ORDER_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal saleOrderId;

    /**
     * 销售计划ID(PLAN_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="销售计划ID",required=false)
    private BigDecimal planId;

    /**
     * 销售订单号(WXSDD-年月日-8位数的顺序号)(SALE_NUMBER,VARCHAR,30)
     */
    @ApiModelProperty(value="销售订单号(WXSDD-年月日-8位数的顺序号)",required=false)
    private String saleNumber;

    /**
     * 发货单位ID(SHIPPER_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="发货单位ID",required=false)
    private BigDecimal shipperId;

    /**
     * 收货单位ID(RECEIVE_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="收货单位ID",required=false)
    private BigDecimal receiveId;

    /**
     * 账户余额(SALE_ACCOUNT_BALANCE,DECIMAL,0)
     */
    @ApiModelProperty(value="账户余额",required=false)
    private BigDecimal saleAccountBalance;

    /**
     * 当前订单金额(SALE_CURRENT_ORDER_AMOUNT,DECIMAL,0)
     */
    @ApiModelProperty(value="当前订单金额",required=false)
    private BigDecimal saleCurrentOrderAmount;

    /**
     * 历史订单金额(SALE_HISTORICAL_ORDER_AMOUNT,DECIMAL,0)
     */
    @ApiModelProperty(value="历史订单金额",required=false)
    private BigDecimal saleHistoricalOrderAmount;

    /**
     * 销售订单状态（0：未上报；1:已上报；2：销售公司已审核通过；3：销售公司已审核未通过；4：财务部已审核通过；5：财务部已审核未通过；）(SALE_ORDER_STATUS,DECIMAL,0)
     */
    @ApiModelProperty(value="销售订单状态（0：未上报；1:已上报；2：销售公司已审核通过；3：销售公司已审核未通过；4：财务部已审核通过；5：财务部已审核未通过；）",required=false)
    private BigDecimal saleOrderStatus;

    /**
     * 收款客户(SALE_ORDER_RECEIVE_CUSTOMER,VARCHAR,250)
     */
    @ApiModelProperty(value="收款客户",required=false)
    private String saleOrderReceiveCustomer;

    /**
     * 是否自提(SALE_ORDER_ISSELF_MENTION,VARCHAR,2)
     */
    @ApiModelProperty(value="是否自提",required=false)
    private String saleOrderIsselfMention;

    /**
     * 单价(SALE_UNIT_PRICE,DECIMAL,0)
     */
    @ApiModelProperty(value="单价",required=false)
    private BigDecimal saleUnitPrice;

    /**
     * 税率(SALE_ORDER_TAX,VARCHAR,20)
     */
    @ApiModelProperty(value="税率",required=false)
    private String saleOrderTax;

    /**
     * 备注(SALE_REMARK,VARCHAR,250)
     */
    @ApiModelProperty(value="备注",required=false)
    private String saleRemark;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,50)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,250)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 是否删除（0：否，1：是）(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否删除（0：否，1：是）",required=false)
    private BigDecimal deleted;

    /**
     * 订单关闭状态(0:未关闭；1：已关闭)(CLOSE_STATUS,DECIMAL,0)
     */
    @ApiModelProperty(value="订单关闭状态(0:未关闭；1：已关闭)",required=false)
    private BigDecimal closeStatus;

    /**
     * 销售员ID(SALER_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="销售员ID",required=false)
    private BigDecimal salerId;

    /**
     * 销售订单类型：（空：化产焦炭和水渣，1：钢材，2：钒渣,4:内转钢材到异地库）(SALE_TYPE,DECIMAL,0)
     */
    @ApiModelProperty(value="销售订单类型：（空：化产焦炭和水渣，1：钢材，2：钒渣,4:内转钢材到异地库）",required=false)
    private BigDecimal saleType;

    /**
     * 调出库存组织(TRANSFER_OUT_INVENTORY_ORG,VARCHAR,50)
     */
    @ApiModelProperty(value="调出库存组织",required=false)
    private String transferOutInventoryOrg;

    /**
     * 调入库存组织(TRANSFER_IN_INVENTORY_ORG,VARCHAR,50)
     */
    @ApiModelProperty(value="调入库存组织",required=false)
    private String transferInInventoryOrg;

    /**
     * 调出部门(TRANSFER_OUT_DEP,VARCHAR,50)
     */
    @ApiModelProperty(value="调出部门",required=false)
    private String transferOutDep;

    /**
     * 调入部门(TRANSFER_IN_DEP,VARCHAR,50)
     */
    @ApiModelProperty(value="调入部门",required=false)
    private String transferInDep;

    /**
     * 业务日期(BUSINESS_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="业务日期",required=false)
    private Date businessDate;

    /**
     * 是否是车皮(WHETHER_THE_CAR,VARCHAR,20)
     */
    @ApiModelProperty(value="是否是车皮",required=false)
    private String whetherTheCar;

    /**
     * 业务类型(BUSINESS_TYPE,VARCHAR,50)
     */
    @ApiModelProperty(value="业务类型",required=false)
    private String businessType;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.saleOrderId;
    }

    @Override
    public void setId(BigDecimal saleOrderId) {
        this.saleOrderId = saleOrderId;
    }

    public BigDecimal getSaleOrderId() {
        return saleOrderId;
    }

    public void setSaleOrderId(BigDecimal saleOrderId) {
        this.saleOrderId = saleOrderId;
    }

    public BigDecimal getPlanId() {
        return planId;
    }

    public void setPlanId(BigDecimal planId) {
        this.planId = planId;
    }

    public String getSaleNumber() {
        return saleNumber;
    }

    public void setSaleNumber(String saleNumber) {
        this.saleNumber = saleNumber == null ? null : saleNumber.trim();
    }

    public BigDecimal getShipperId() {
        return shipperId;
    }

    public void setShipperId(BigDecimal shipperId) {
        this.shipperId = shipperId;
    }

    public BigDecimal getReceiveId() {
        return receiveId;
    }

    public void setReceiveId(BigDecimal receiveId) {
        this.receiveId = receiveId;
    }

    public BigDecimal getSaleAccountBalance() {
        return saleAccountBalance;
    }

    public void setSaleAccountBalance(BigDecimal saleAccountBalance) {
        this.saleAccountBalance = saleAccountBalance;
    }

    public BigDecimal getSaleCurrentOrderAmount() {
        return saleCurrentOrderAmount;
    }

    public void setSaleCurrentOrderAmount(BigDecimal saleCurrentOrderAmount) {
        this.saleCurrentOrderAmount = saleCurrentOrderAmount;
    }

    public BigDecimal getSaleHistoricalOrderAmount() {
        return saleHistoricalOrderAmount;
    }

    public void setSaleHistoricalOrderAmount(BigDecimal saleHistoricalOrderAmount) {
        this.saleHistoricalOrderAmount = saleHistoricalOrderAmount;
    }

    public BigDecimal getSaleOrderStatus() {
        return saleOrderStatus;
    }

    public void setSaleOrderStatus(BigDecimal saleOrderStatus) {
        this.saleOrderStatus = saleOrderStatus;
    }

    public String getSaleOrderReceiveCustomer() {
        return saleOrderReceiveCustomer;
    }

    public void setSaleOrderReceiveCustomer(String saleOrderReceiveCustomer) {
        this.saleOrderReceiveCustomer = saleOrderReceiveCustomer == null ? null : saleOrderReceiveCustomer.trim();
    }

    public String getSaleOrderIsselfMention() {
        return saleOrderIsselfMention;
    }

    public void setSaleOrderIsselfMention(String saleOrderIsselfMention) {
        this.saleOrderIsselfMention = saleOrderIsselfMention == null ? null : saleOrderIsselfMention.trim();
    }

    public BigDecimal getSaleUnitPrice() {
        return saleUnitPrice;
    }

    public void setSaleUnitPrice(BigDecimal saleUnitPrice) {
        this.saleUnitPrice = saleUnitPrice;
    }

    public String getSaleOrderTax() {
        return saleOrderTax;
    }

    public void setSaleOrderTax(String saleOrderTax) {
        this.saleOrderTax = saleOrderTax == null ? null : saleOrderTax.trim();
    }

    public String getSaleRemark() {
        return saleRemark;
    }

    public void setSaleRemark(String saleRemark) {
        this.saleRemark = saleRemark == null ? null : saleRemark.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public BigDecimal getCloseStatus() {
        return closeStatus;
    }

    public void setCloseStatus(BigDecimal closeStatus) {
        this.closeStatus = closeStatus;
    }

    public BigDecimal getSalerId() {
        return salerId;
    }

    public void setSalerId(BigDecimal salerId) {
        this.salerId = salerId;
    }

    public BigDecimal getSaleType() {
        return saleType;
    }

    public void setSaleType(BigDecimal saleType) {
        this.saleType = saleType;
    }

    public String getTransferOutInventoryOrg() {
        return transferOutInventoryOrg;
    }

    public void setTransferOutInventoryOrg(String transferOutInventoryOrg) {
        this.transferOutInventoryOrg = transferOutInventoryOrg == null ? null : transferOutInventoryOrg.trim();
    }

    public String getTransferInInventoryOrg() {
        return transferInInventoryOrg;
    }

    public void setTransferInInventoryOrg(String transferInInventoryOrg) {
        this.transferInInventoryOrg = transferInInventoryOrg == null ? null : transferInInventoryOrg.trim();
    }

    public String getTransferOutDep() {
        return transferOutDep;
    }

    public void setTransferOutDep(String transferOutDep) {
        this.transferOutDep = transferOutDep == null ? null : transferOutDep.trim();
    }

    public String getTransferInDep() {
        return transferInDep;
    }

    public void setTransferInDep(String transferInDep) {
        this.transferInDep = transferInDep == null ? null : transferInDep.trim();
    }

    public Date getBusinessDate() {
        return businessDate;
    }

    public void setBusinessDate(Date businessDate) {
        this.businessDate = businessDate;
    }

    public String getWhetherTheCar() {
        return whetherTheCar;
    }

    public void setWhetherTheCar(String whetherTheCar) {
        this.whetherTheCar = whetherTheCar == null ? null : whetherTheCar.trim();
    }

    public String getBusinessType() {
        return businessType;
    }

    public void setBusinessType(String businessType) {
        this.businessType = businessType == null ? null : businessType.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", saleOrderId=").append(saleOrderId);
        sb.append(", planId=").append(planId);
        sb.append(", saleNumber=").append(saleNumber);
        sb.append(", shipperId=").append(shipperId);
        sb.append(", receiveId=").append(receiveId);
        sb.append(", saleAccountBalance=").append(saleAccountBalance);
        sb.append(", saleCurrentOrderAmount=").append(saleCurrentOrderAmount);
        sb.append(", saleHistoricalOrderAmount=").append(saleHistoricalOrderAmount);
        sb.append(", saleOrderStatus=").append(saleOrderStatus);
        sb.append(", saleOrderReceiveCustomer=").append(saleOrderReceiveCustomer);
        sb.append(", saleOrderIsselfMention=").append(saleOrderIsselfMention);
        sb.append(", saleUnitPrice=").append(saleUnitPrice);
        sb.append(", saleOrderTax=").append(saleOrderTax);
        sb.append(", saleRemark=").append(saleRemark);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", closeStatus=").append(closeStatus);
        sb.append(", salerId=").append(salerId);
        sb.append(", saleType=").append(saleType);
        sb.append(", transferOutInventoryOrg=").append(transferOutInventoryOrg);
        sb.append(", transferInInventoryOrg=").append(transferInInventoryOrg);
        sb.append(", transferOutDep=").append(transferOutDep);
        sb.append(", transferInDep=").append(transferInDep);
        sb.append(", businessDate=").append(businessDate);
        sb.append(", whetherTheCar=").append(whetherTheCar);
        sb.append(", businessType=").append(businessType);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}