package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="销售日志表")
public class SaleLog implements IBasePO<BigDecimal> {
    @ApiModelProperty(value="",required=true)
    private BigDecimal resultId;

    /**
     * 运单ID(ORDER_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="运单ID",required=false)
    private BigDecimal orderId;

    /**
     * 销售订单ID(SALE_ORDER_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="销售订单ID",required=false)
    private BigDecimal saleOrderId;

    /**
     * 日志描述(DESCRIPTION,VARCHAR,255)
     */
    @ApiModelProperty(value="日志描述",required=false)
    private String description;

    /**
     * 操作类型(OPRATION_TYPE,VARCHAR,20)
     */
    @ApiModelProperty(value="操作类型",required=false)
    private String oprationType;

    /**
     * 可能存在的JSON数据(JSON_DATA,VARCHAR,255)
     */
    @ApiModelProperty(value="可能存在的JSON数据",required=false)
    private String jsonData;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.resultId;
    }

    @Override
    public void setId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getResultId() {
        return resultId;
    }

    public void setResultId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getOrderId() {
        return orderId;
    }

    public void setOrderId(BigDecimal orderId) {
        this.orderId = orderId;
    }

    public BigDecimal getSaleOrderId() {
        return saleOrderId;
    }

    public void setSaleOrderId(BigDecimal saleOrderId) {
        this.saleOrderId = saleOrderId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description == null ? null : description.trim();
    }

    public String getOprationType() {
        return oprationType;
    }

    public void setOprationType(String oprationType) {
        this.oprationType = oprationType == null ? null : oprationType.trim();
    }

    public String getJsonData() {
        return jsonData;
    }

    public void setJsonData(String jsonData) {
        this.jsonData = jsonData == null ? null : jsonData.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", resultId=").append(resultId);
        sb.append(", orderId=").append(orderId);
        sb.append(", saleOrderId=").append(saleOrderId);
        sb.append(", description=").append(description);
        sb.append(", oprationType=").append(oprationType);
        sb.append(", jsonData=").append(jsonData);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}